Texture2D output : register(t1);
SamplerState samplerState : register(s0);

struct InputType
{
	float4 pos : POSITION;
	float2 tex : TEXCOORD0;
	float3 norm : NORMAL;
	float2 tex1 : TEXCOORD1;
	float2 tex2 : TEXCOORD2;
	float2 tex3 : TEXCOORD3;
	float2 tex4 : TEXCOORD4;
	float2 tex5 : TEXCOORD5;
	float2 tex6 : TEXCOORD6;
	float2 tex7 : TEXCOORD7;
	float2 tex8 : TEXCOORD8;
	float2 tex9 : TEXCOORD9;
};

float4 main(InputType input) : SV_TARGET
{
	//initialise and get alpha
	float4 colour = output.Sample(samplerState, input.tex);

	//blur rgb
	colour.rgb = 0.0f.xxx;
	colour.rgb += output.Sample(samplerState, input.tex1);
	colour.rgb += output.Sample(samplerState, input.tex2)*2;
	colour.rgb += output.Sample(samplerState, input.tex3)*4;
	colour.rgb += output.Sample(samplerState, input.tex4)*8;
	colour.rgb += output.Sample(samplerState, input.tex5)*16;
	colour.rgb += output.Sample(samplerState, input.tex6)*8;
	colour.rgb += output.Sample(samplerState, input.tex7)*4;
	colour.rgb += output.Sample(samplerState, input.tex8)*2;
	colour.rgb += output.Sample(samplerState, input.tex9);

	colour.rgb /= 46;

	//contrast rgb
	colour.rgb = colour.rgb / (sqrt(1 + (colour.rgb*colour.rgb)));
	
	//gamma correction rgb
	colour.rgb = pow(colour.rgb, 1.25);
	return colour;
}