//Tessellate triangles by a factor of 10

struct InputType
{
	float4 position : POSITION;
	float2 tex : TEXCOORD0;
	float3 normal : NORMAL;
};

struct ConstantOutputType
{
	float edges[3] : SV_TESSFACTOR;
	float inside : SV_INSIDETESSFACTOR;
};

struct OutputType
{
	float4 position : POSITION;
	float2 tex : TEXCOORD0;
	float3 normal : NORMAL;
};

ConstantOutputType PatchConstantFunction(InputPatch<InputType, 3> inputPatch, uint patchID : SV_PrimitiveID)
{
	ConstantOutputType output;

	for (int i = 0; i < 3; ++i)
	{
		output.edges[i] = 10;

	}
	output.inside = 10;

	return output;
}

[domain("tri")]
[partitioning("integer")]
[outputtopology("triangle_cw")]
[outputcontrolpoints(3)]
[patchconstantfunc("PatchConstantFunction")]
[maxtessfactor(64.0f)]
OutputType main(InputPatch<InputType, 3> input, uint pointID : SV_OutputControlPointID, uint patchID : SV_PrimitiveID)
{
	OutputType output;

	output = input[pointID];

	return output;
}